﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace TechNote50_DataGrid_CS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // DataGrid의 데이터를 처리하기 위한 데이터 객체 선언
        private DataSet m_DataSet;
        private DataTable m_DataTable;
        private USERDATA m_NowSelectUserData;
        
        private int AddInsMod = 0;

        // 현재 DataGrid에서 선택된 항목의 정보를 구조체 선언 
        private struct USERDATA
        {
            public int m_iNowSelectIndex;
            public string m_strName;
            public string m_strAddress;
            public string m_strPhone;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // 현재 Form을 MainForm으로 설정합니다.
            smartForm1.MainForm = this;

            smartGroupBox1.Top = 250;
            smartGroupBox1.Left = 30;
            smartGroupBox1.Visible = false;

            // DataGrid Header 출력
            DataGridHeaderDisplay();

            // DataGrid에 항목 추가
            AddRowData("Kim Jin Man", "서울시 강남구 대치동", "000-1234-5678");
            AddRowData("홍길동", "서울시 금천구 가산동 429-1", "000-0000-0000");
            AddRowData("C#", "Visual Studio 2005 - MicroSoft", "111-2222-3333");
            AddRowData("NonameC#", "서울시 동작구 신대방동", "012-3456-7891");
        }

        // Data Grid의 Header 및 항목 설정
        private void DataGridHeaderDisplay()
        {
            // Create a DataSet.
            m_DataSet = new DataSet("DataSet");

            // Create a DataTable.
            m_DataTable = new DataTable("Customers");

            // Grid의 Header 항목을 설정 합니다.
            DataColumn cNo = new DataColumn("No.", typeof(int));
            DataColumn cName = new DataColumn("Name");
            DataColumn cAddress = new DataColumn("Address");
            DataColumn cPhone = new DataColumn("Phone");
            m_DataTable.Columns.Add(cNo);
            m_DataTable.Columns.Add(cName);
            m_DataTable.Columns.Add(cAddress);
            m_DataTable.Columns.Add(cPhone);

            // Add the table to the DataSet.
            m_DataSet.Tables.Add(m_DataTable);

            // Cell Width 설정
            DataGridTableStyle TableStyle = new DataGridTableStyle();
            TableStyle.MappingName = "Customers";

            DataGridColumnStyle cNoStyle = new DataGridTextBoxColumn();
            cNoStyle.MappingName = "No.";
            cNoStyle.HeaderText = "No.";
            cNoStyle.Width = 55;
            TableStyle.GridColumnStyles.Add(cNoStyle);

            DataGridColumnStyle cNameStyle = new DataGridTextBoxColumn();
            cNameStyle.MappingName = "Name";
            cNameStyle.HeaderText = "Name";
            cNameStyle.Width = 170;
            TableStyle.GridColumnStyles.Add(cNameStyle);

            DataGridColumnStyle cAddressStyle = new DataGridTextBoxColumn();
            cAddressStyle.MappingName = "Address";
            cAddressStyle.HeaderText = "Address";
            cAddressStyle.Width = 370;
            TableStyle.GridColumnStyles.Add(cAddressStyle);

            DataGridColumnStyle cPhoneStyle = new DataGridTextBoxColumn();
            cPhoneStyle.MappingName = "Phone";
            cPhoneStyle.HeaderText = "Phone";
            cPhoneStyle.Width = 187;
            TableStyle.GridColumnStyles.Add(cPhoneStyle);

            // Datagrid 속성 색상 설정
            dataGrid1.TableStyles.Add(TableStyle);
            dataGrid1.HeaderBackColor = Color.Blue;
            dataGrid1.HeaderForeColor = Color.White;
            dataGrid1.RowHeadersVisible = false;

            dataGrid1.SelectionBackColor = Color.Pink;
            dataGrid1.SelectionForeColor = Color.Magenta;

            // DataGrid의 데이터를 표현하기위한 데이터 Tabel설정
            dataGrid1.DataSource = m_DataSet.Tables[0];

            // 폰트 설정
            dataGrid1.Font = new Font("Tahoma", 12, FontStyle.Bold);
        }

        // Row 데이터 삽입 추가
        private void InsertRowDatas(int iRowIndex, string strName, string strAddress, string strPhone, bool bInsertFlag)
        {
            DataRow newRow1;

            newRow1 = m_DataTable.NewRow();
            newRow1["No."] = iRowIndex;

            m_DataTable.Rows.InsertAt(newRow1, iRowIndex);

            m_DataTable.Rows[iRowIndex]["Name"] = strName;
            m_DataTable.Rows[iRowIndex]["Address"] = strAddress;
            m_DataTable.Rows[iRowIndex]["Phone"] = strPhone;

            // Insert인 경우 No. Field의 데이터를 전부 다시 Numbering
            if (bInsertFlag == true)
            {
                for (int i = 0; i < m_DataTable.Rows.Count; i++)
                {
                    m_DataTable.Rows[i]["No."] = i.ToString();
                }
            }

            dataGrid1.DataSource = m_DataSet.Tables[0];
        }

        // Row 데이터 삽입 추가
        private void InsertRowData(int iRowIndex, string strName, string strAddress, string strPhone)
        {
            InsertRowDatas(iRowIndex, strName, strAddress, strPhone, true);
        }

        // 마지막 항목에 데이터 추가
        private void AddRowData(string strName, string strAddress, string strPhone)
        {
            int iRowIndex;

            iRowIndex = m_DataTable.Rows.Count;

            InsertRowDatas(iRowIndex, strName, strAddress, strPhone, false);
        }

        // 선택한 항목 삭제
        private void DeleteRowData(int iRowIndex)
        {
            if (IsRowDataCheck(iRowIndex) == true)
            {
                m_DataTable.Rows[iRowIndex].Delete();
            }
        }

        // 항목을 변경 합니다.
        private void ModifyRowData(int iRowIndex, string strName, string strAddress, string strPhone)
        {
            if (IsRowDataCheck(iRowIndex) == true)
            {
                m_DataTable.Rows[iRowIndex]["Name"] = strName;
                m_DataTable.Rows[iRowIndex]["Address"] = strAddress;
                m_DataTable.Rows[iRowIndex]["Phone"] = strPhone;

                dataGrid1.DataSource = m_DataSet.Tables[0];
            }
        }

        // 현재 선택된 항목이 존재 하는지 검사 
        private bool IsRowDataCheck(int iRowIndex)
        {
            if (m_DataTable.Rows.Count > iRowIndex)
            {
                return true;
            }

            return false;
        }

        private void dataGrid1_MouseUp(object sender, MouseEventArgs e)
        {
            DataGrid myGrid = (DataGrid)sender;

            DataGrid.HitTestInfo myHitInfo = myGrid.HitTest(e.X, e.Y);

            // 선텍된 항목의 필드 정보를 얻는다.
            if (myHitInfo.Type == DataGrid.HitTestType.Cell)
            {
                m_NowSelectUserData.m_iNowSelectIndex = myHitInfo.Row;
                m_NowSelectUserData.m_strAddress = m_DataTable.Rows[m_NowSelectUserData.m_iNowSelectIndex]["Address"].ToString();
                m_NowSelectUserData.m_strName = m_DataTable.Rows[m_NowSelectUserData.m_iNowSelectIndex]["Name"].ToString();
                m_NowSelectUserData.m_strPhone = m_DataTable.Rows[m_NowSelectUserData.m_iNowSelectIndex]["Phone"].ToString();

            }
        }

        // 항목 추가 버튼
        private void btnAdd_Click(object sender, EventArgs e)
        {
            smartGroupBox1.Visible = true;
            
            AddInsMod = 1;
        }

        private void btnApply_Click(object sender, EventArgs e)
        {
            if (AddInsMod == 1)
            {
                // 항목 추가 적용 버튼
                AddRowData(labName.Text, labAddress.Text, labPhone.Text);
            }
            else if (AddInsMod == 2)
            {
                // 항목 삽입 추가
                InsertRowData(m_NowSelectUserData.m_iNowSelectIndex, labName.Text, labAddress.Text, labPhone.Text);
            }
            else
            {
                // 내용 변경 적용 버튼
                ModifyRowData(m_NowSelectUserData.m_iNowSelectIndex, labName.Text, labAddress.Text, labPhone.Text);
            }

            smartGroupBox1.Visible = false;
            smartKeyboard1.Hide();
        }

        // 입력(추가, 변경) 적용 취소
        private void btnCancel_Click(object sender, EventArgs e)
        {
            smartGroupBox1.Visible = false;
            smartKeyboard1.Hide();
        }

        // 선택된 항목 삭제
        private void btnDelete_Click(object sender, EventArgs e)
        {
            DeleteRowData(m_NowSelectUserData.m_iNowSelectIndex);
        }

        // 항목 삽입 하기
        private void btnInsert_Click(object sender, EventArgs e)
        {
            smartGroupBox1.Visible = true;
            
            AddInsMod = 2; 
        }

        // 항목 변경 하기
        private void btnModify_Click(object sender, EventArgs e)
        {
            smartGroupBox1.Visible = true;
            labAddress.Text = m_NowSelectUserData.m_strAddress;
            labName.Text = m_NowSelectUserData.m_strName;
            labPhone.Text = m_NowSelectUserData.m_strPhone;
            AddInsMod = 3; 
        }

        private void SmartLabel_Click(object sender, EventArgs e)
        {
            smartKeyboard1.Show();
            smartKeyboard1.Location = new Point(100, 50);

            if (sender == labName)
            {
                smartKeyboard1.TargetInputObject = labName;
            }
            else if (sender == labAddress)
            {
                smartKeyboard1.TargetInputObject = labAddress;
            }
            else
            {
                smartKeyboard1.TargetInputObject = labPhone;
            }
        }
    }
}