﻿Imports System.Data

Public Class Form1

    ' DataGrid의 데이터를 처리하기 위한 데이터 객체 선언
    Private m_DataSet As DataSet
    Private m_DataTable As DataTable
    Private m_NowSelectUserData As USERDATA

    Private AddInsMod As Integer = 0

    ' 현재 DataGrid에서 선택된 항목의 정보를 구조체 선언 
    Private Structure USERDATA
        Public m_iNowSelectIndex As Integer
        Public m_strName As String
        Public m_strAddress As String
        Public m_strPhone As String
    End Structure

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        ' 현재 Form을 MainForm으로 설정합니다.
        SmartForm1.MainForm = Me

        smartGroupBox1.Top = 250
        smartGroupBox1.Left = 30
        smartGroupBox1.Visible = False

        ' DataGrid Header 출력
        DataGridHeaderDisplay()

        ' DataGrid에 항목 추가
        AddRowData("Kim Jin Man", "서울시 강남구 대치동", "000-1234-5678")
        AddRowData("홍길동", "서울시 금천구 가산동 429-1", "000-0000-0000")
        AddRowData("C#", "Visual Studio 2005 - MicroSoft", "111-2222-3333")
        AddRowData("NonameC#", "서울시 동작구 신대방동", "012-3456-7891")
    End Sub

    ' Data Grid의 Header 및 항목 설정
    Private Sub DataGridHeaderDisplay()
        ' Create a DataSet.
        m_DataSet = New DataSet("DataSet")

        ' Create a DataTable.
        m_DataTable = New DataTable("Customers")

        ' Grid의 Header 항목을 설정 합니다.
        Dim cNo As DataColumn = New DataColumn("No.", GetType(Integer))
        Dim cName As DataColumn = New DataColumn("Name")
        Dim cAddress As DataColumn = New DataColumn("Address")
        Dim cPhone As DataColumn = New DataColumn("Phone")
        m_DataTable.Columns.Add(cNo)
        m_DataTable.Columns.Add(cName)
        m_DataTable.Columns.Add(cAddress)
        m_DataTable.Columns.Add(cPhone)

        ' Add the table to the DataSet.
        m_DataSet.Tables.Add(m_DataTable)

        ' Cell Width 설정
        Dim TableStyle As DataGridTableStyle = New DataGridTableStyle()
        TableStyle.MappingName = "Customers"

        Dim cNoStyle As DataGridColumnStyle = New DataGridTextBoxColumn()
        cNoStyle.MappingName = "No."
        cNoStyle.HeaderText = "No."
        cNoStyle.Width = 55
        TableStyle.GridColumnStyles.Add(cNoStyle)

        Dim cNameStyle As DataGridColumnStyle = New DataGridTextBoxColumn()
        cNameStyle.MappingName = "Name"
        cNameStyle.HeaderText = "Name"
        cNameStyle.Width = 170
        TableStyle.GridColumnStyles.Add(cNameStyle)

        Dim cAddressStyle As DataGridColumnStyle = New DataGridTextBoxColumn()
        cAddressStyle.MappingName = "Address"
        cAddressStyle.HeaderText = "Address"
        cAddressStyle.Width = 370
        TableStyle.GridColumnStyles.Add(cAddressStyle)

        Dim cPhoneStyle As DataGridColumnStyle = New DataGridTextBoxColumn()
        cPhoneStyle.MappingName = "Phone"
        cPhoneStyle.HeaderText = "Phone"
        cPhoneStyle.Width = 187
        TableStyle.GridColumnStyles.Add(cPhoneStyle)

        ' Datagrid 속성 색상 설정
        dataGrid1.TableStyles.Add(TableStyle)
        dataGrid1.HeaderBackColor = Color.Blue
        dataGrid1.HeaderForeColor = Color.White
        dataGrid1.RowHeadersVisible = False

        dataGrid1.SelectionBackColor = Color.Pink
        dataGrid1.SelectionForeColor = Color.Magenta

        ' DataGrid의 데이터를 표현하기위한 데이터 Tabel설정
        dataGrid1.DataSource = m_DataSet.Tables(0)

        ' 폰트 설정
        dataGrid1.Font = New Font("Tahoma", 12, FontStyle.Bold)
    End Sub

    ' Row 데이터 삽입 추가
    Private Sub InsertRowDatas(ByVal iRowIndex As Integer, ByVal strName As String, ByVal strAddress As String, ByVal strPhone As String, ByVal bInsertFlag As Boolean)
        Dim newRow1 As DataRow

        newRow1 = m_DataTable.NewRow()
        newRow1("No.") = iRowIndex

        m_DataTable.Rows.InsertAt(newRow1, iRowIndex)

        m_DataTable.Rows(iRowIndex)("Name") = strName
        m_DataTable.Rows(iRowIndex)("Address") = strAddress
        m_DataTable.Rows(iRowIndex)("Phone") = strPhone

        ' Insert인 경우 No. Field의 데이터를 전부 다시 Numbering
        If bInsertFlag = True Then
            For i As Integer = 0 To m_DataTable.Rows.Count - 1
                m_DataTable.Rows(i)("No.") = i.ToString()
            Next
        End If

        dataGrid1.DataSource = m_DataSet.Tables(0)
    End Sub

    ' Row 데이터 삽입 추가
    Private Sub InsertRowData(ByVal iRowIndex As Integer, ByVal strName As String, ByVal strAddress As String, ByVal strPhone As String)
        InsertRowDatas(iRowIndex, strName, strAddress, strPhone, True)
    End Sub

    ' 마지막 항목에 데이터 추가
    Private Sub AddRowData(ByVal strName As String, ByVal strAddress As String, ByVal strPhone As String)
        Dim iRowIndex As Integer

        iRowIndex = m_DataTable.Rows.Count

        InsertRowDatas(iRowIndex, strName, strAddress, strPhone, False)
    End Sub

    ' 선택한 항목 삭제
    Private Sub DeleteRowData(ByVal iRowIndex As Integer)
        If IsRowDataCheck(iRowIndex) = True Then
            m_DataTable.Rows(iRowIndex).Delete()
        End If
    End Sub

    ' 항목을 변경 합니다.
    Private Sub ModifyRowData(ByVal iRowIndex As Integer, ByVal strName As String, ByVal strAddress As String, ByVal strPhone As String)
        If IsRowDataCheck(iRowIndex) = True Then
            m_DataTable.Rows(iRowIndex)("Name") = strName
            m_DataTable.Rows(iRowIndex)("Address") = strAddress
            m_DataTable.Rows(iRowIndex)("Phone") = strPhone

            dataGrid1.DataSource = m_DataSet.Tables(0)
        End If
    End Sub

    Private Function IsRowDataCheck(ByVal iRowIndex As Integer) As Boolean
        If m_DataTable.Rows.Count > iRowIndex Then
            Return True
        End If

        Return False
    End Function

    Private Sub dataGrid1_MouseUp(ByVal sender As Object, ByVal e As MouseEventArgs) Handles dataGrid1.MouseUp
        Dim myGrid As DataGrid = CType(sender, DataGrid)

        Dim myHitInfo As DataGrid.HitTestInfo = myGrid.HitTest(e.X, e.Y)

        ' 선텍된 항목의 필드 정보를 얻는다.
        If myHitInfo.Type = DataGrid.HitTestType.Cell Then
            m_NowSelectUserData.m_iNowSelectIndex = myHitInfo.Row
            m_NowSelectUserData.m_strAddress = m_DataTable.Rows(m_NowSelectUserData.m_iNowSelectIndex)("Address").ToString()
            m_NowSelectUserData.m_strName = m_DataTable.Rows(m_NowSelectUserData.m_iNowSelectIndex)("Name").ToString()
            m_NowSelectUserData.m_strPhone = m_DataTable.Rows(m_NowSelectUserData.m_iNowSelectIndex)("Phone").ToString()
        End If
    End Sub

    ' 항목 추가 버튼
    Private Sub btnAdd_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnAdd.Click
        smartGroupBox1.Visible = True
        AddInsMod = 1
    End Sub

    Private Sub btnApply_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnApply.Click
        If AddInsMod = 1 Then
            ' 항목 추가 적용 버튼
            AddRowData(labName.Text, labAddress.Text, labPhone.Text)
        ElseIf AddInsMod = 2 Then
            ' 항목 삽입 추가
            InsertRowData(m_NowSelectUserData.m_iNowSelectIndex, labName.Text, labAddress.Text, labPhone.Text)
        Else
            ' 내용 변경 적용 버튼
            ModifyRowData(m_NowSelectUserData.m_iNowSelectIndex, labName.Text, labAddress.Text, labPhone.Text)
        End If

        smartGroupBox1.Visible = False
        smartKeyboard1.Hide()
    End Sub

    ' 입력(추가, 변경) 적용 취소
    Private Sub btnCancel_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnCancel.Click
        smartGroupBox1.Visible = False
        smartKeyboard1.Hide()
    End Sub

    ' 선택된 항목 삭제
    Private Sub btnDelete_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnDelete.Click
        DeleteRowData(m_NowSelectUserData.m_iNowSelectIndex)
    End Sub

    ' 항목 삽입 하기
    Private Sub btnInsert_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnInsert.Click
        smartGroupBox1.Visible = True
        AddInsMod = 2
    End Sub

    ' 항목 변경 하기
    Private Sub btnModify_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnModify.Click
        smartGroupBox1.Visible = True
        labAddress.Text = m_NowSelectUserData.m_strAddress
        labName.Text = m_NowSelectUserData.m_strName
        labPhone.Text = m_NowSelectUserData.m_strPhone
        AddInsMod = 3
    End Sub

    Private Sub SmartLabel_Click(ByVal sender As Object, ByVal e As EventArgs) Handles labPhone.Click, labName.Click, labAddress.Click
        smartKeyboard1.Show()
        smartKeyboard1.Location = New Point(100, 50)

        If sender Is labName Then
            smartKeyboard1.TargetInputObject = labName
        ElseIf sender Is labAddress Then
            smartKeyboard1.TargetInputObject = labAddress
        Else
            smartKeyboard1.TargetInputObject = labPhone
        End If
    End Sub
End Class
